$(document).ready(function () {
    $('body').on('blur', '.setoff', setoff);
    $('body').on('keyup', '#recd, #discount, #dclaim', calculateRow);
    $('body').on('click', '.mark, #mclaim', setclaim);

    function showDays(firstDate, secondDate) {
        var date1 = firstDate;
        var date2 = secondDate.split("-").reverse().join("-");
        var mfirstday = new Date(date1);
        var mlastday = new Date(date2);
        var distance
        if (mfirstday > mlastday) {
            distance = mfirstday.getTime() - mlastday.getTime();
            distance = Math.ceil(distance / 1000 / 60 / 60 / 24);
        } else {
            distance = 0;
        }
        return distance;
    }

    $(".settotal").hide();

    function setoff() {
        var val = 0;
        var $row = $(this).closest("tr");
        var msetoff = parseFloat($row.find('.setoff').val()),
                mbalamt = parseFloat($row.find('.balamt2').val()),
                mbilamt = parseFloat($row.find('.billamt').val()),
                amtadj = parseFloat($row.find(".amtadj").val()),
                mbilldate = $row.find('.billdate').val(),
                mvouchdt = $('#vouchdt').val();
        if (isNaN(msetoff)) {
            msetoff = 0;
        }

        var newval = (mbilamt - amtadj).toFixed(2);
//        alert(newval);
        if (msetoff > newval) {
            $row.find('.setoff').val(0);
//            $row.find('.setoff').focus();
            msetoff = 0;
            alert("SETOFF AMOUNT CANNOT BE GREATER THAN BALANCE AMOUNT");
            $("#save").attr("disabled", "disabled");
            parseFloat($row.find('.balamt').val(mbalamt.toFixed(2)));

        } else {

            var balance = (mbilamt - amtadj - msetoff).toFixed(2);
            $row.find(".balamt").val(balance);

//        var remain = $("#remain").val();



            var mamt = $('#amount').val();

            /*********Total Part************/

            $(".setoff").each(function () {
                if (!isNaN(this.value) && this.value.length != 0) {
                    val += parseFloat(this.value);
                }
            });

            if (val > mamt) {
                $row.find('.setoff').val(0);
                $row.find('.setoff').focus();
                alert("TOTAL SETOFF AMOUNT CANNOT BE GREATER THAN TOTAL AMOUNT");
                $("#save").attr("disabled", "disabled");
            } else {
                $("#totsetoff").val(val.toFixed(2));
                $("#save").removeAttr("disabled");

                var totdays = showDays(mvouchdt, mbilldate);
//                            alert(totdays);

                var totremain = mamt - val;

                $row.find('.days').val(totdays);
                $("#remain").val(totremain.toFixed(2));
            }
        }
    }
//    function addrows() {
//
//        var ctr = $('#items').val();
//        $.post('billsett.php', {ctr: ctr}, function (data) {
//            $(data).appendTo('#data');
//            ctr++;
//            $('#items').val(ctr);
//        });
//    }

    function parseDate(str) {
        var mdy = str.split('/')
        return new Date(mdy[2], mdy[0] - 1, mdy[1]);
    }

    function daydiff(first, second) {
        return (second - first) / (1000 * 60 * 60 * 24)
    }


//    $('#addnew').click(function () {
//        addrows();
//    });


    function billsett() {
        $('#data').empty();
        var accode = $('#party').val();
        var vouchno = $('#vouchno').val();
        var vouchdt = $('#vouchdt').val();
        var amount = $('#amount').val();
        var bankcode = $('#bankcode').val();
        var dbfname = $('#dbfname').val();
        var source = $('#source').val();
        var pvar = $('#pvar').val();

        $.get('billsett.php',
                {accode: accode,
                    vouchno: vouchno,
                    vouchdt: vouchdt,
                    amount: amount,
                    bank: bankcode,
                    dbf: dbfname,
                    pvar: pvar,
                    source: source
                }, function (data) {
            $('#data').html(data);

        });
    }

    $('#billsett').click(function () {
        billsett();
    });

    $('#amount').blur(function () {
        $(".settotal").show();
        $(".billflag").val("1");

        $("#settmodal").modal("show");
        $("#settmodal").on('shown.bs.modal', function () {
            $("#setoff_1").focus();
        });
        billsett();
    });
//    as said by ashraf(mateen bhai staff)
    $(document).keydown(function (event) {
        //19 for Mac Command+S
        if (event.keyCode == 27) { // escape key maps to keycode `27`
            // <DO YOUR WORK HERE>
            $("#settmodal").modal("hide");
        }
    });


    function calculateRow() {
        var fintot = 0;
        var subtot = parseFloat($('#recd').val());
        var discount = parseFloat($('#discount').val());
        var claim = parseFloat($('#dclaim').val());

        fintot = subtot + discount + claim;

        if (isNaN(fintot)) {
            $('#amount').val("0");
        } else {
            $('#amount').val(fintot.toFixed(1));
        }
    }

    $("#mclaim").click(function () {
        var code = $("#party").val();
        $.post('get_claim.php', {code: code, var : "R"}, function (data) {
            $('#browdata').html("");
            $('#browdata').append(data);
            $("#overlay_form").fadeIn(1000);
            positionPopup();

        });
    });

    function setclaim() {

        var $row = $(this).closest("tr");
        var vouch = $('#vouchno').val();
        var vouchdt = $('#mvouchdt').val();
        //  var claim   = $('#claim').val();
        var mval = 0;
        var mark = $row.find('.mark');
        //          if($row.find(".mark").is(":checked")) {
        var mtot = 0;
        var cl = parseFloat($("#dclaim").val());
        if ($row.find(".mark").is(":checked")) {
            mtot = cl + parseFloat($row.find(".billamt").val());

        } else {
            mtot = cl - parseFloat($row.find(".billamt").val());
        }
        $("#dclaim").val(mtot.toFixed(2));



        /*        $($(".mark").is(":checked")).each( function() {
         var bamt = parseFloat($(".billamt").val());
         mtot = mtot + bamt;       
         });*/


        /*$(".billamt").each(function() {
         if ($row.find(".mark").is(":checked")) {
         mtot = mtot + parseFloat($row.find(".billamt").val());
         alert(mtot);
         }
         });*/
    }
});